<?php
ini_set('display_errors', 1);

require_once '../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . '/user_management/check_username_availability.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'functions/common_functions.php';

//db access function
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';

$postdata = json_decode(file_get_contents("php://input"), true);
//print_r($postdata);
checkIfNoPhpContentsReceive();

if (
    !isset($postdata['institution_id']) or !checkIfIssetAndNotEmpty($postdata['institution_id'])  or
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or
    !isset($postdata['jwt_token']) or  !isset($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}

validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
//then workspace_id is iin decodede data of jwt use from there
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id, null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

function getInstitutionSiteSettings($conn_rjllearning_specific, $institution_id,  $search_string, $limit, $offset)
{
 
    $sql_count = "SELECT COUNT(*) AS total_rows FROM site_settings WHERE institution_id = ? ";
    $array_params = [$institution_id];
    $stmt = $conn_rjllearning_specific->prepare($sql_count);
    $stmt->execute($array_params);
    $result_total = $stmt->fetchAll();
    $totalrows = $result_total[0]['total_rows'];
    
    if ($limit == 'all') {
        $sql_class = "SELECT id, institution_id, site_ui_settings FROM site_settings WHERE institution_id = ?";
        $array_params = [$institution_id];
        
        if ($search_string != null) {
            $sql_class .= " AND JSON_EXTRACT(site_ui_settings, '$.sidebar_background_color') LIKE ?";
            $array_params[] = '%' . $search_string . '%';
        }
        
    } else {
        $sql_class = "SELECT id, institution_id, site_ui_settings FROM site_settings WHERE institution_id = ?";
        $array_params = [$institution_id];
        
        if ($search_string != null) {
            $sql_class .= " AND JSON_EXTRACT(site_ui_settings, '$.sidebar_background_color') LIKE ?";
            $array_params[] = '%' . $search_string . '%';
        }
        $sql_class .= " LIMIT " . $offset . ", " . $limit;
    }
    
    $stmt = $conn_rjllearning_specific->prepare($sql_class);
    $stmt->execute($array_params);
    $result_class = $stmt->fetchAll();
    
    $array_return = [];
    
    if (count($result_class) >= 1) {
        foreach ($result_class as $rows) {
            $settings = json_decode($rows['site_ui_settings'], true);
            $array_return[] = [
                'setting_id' => $rows['id'],
                'institution_id' => $rows['institution_id'],
                'sidebar_background_color' => $settings['sidebar_background_color'],
                'sidebar_menulist_bg' => $settings['sidebar_menulist_bg'],
                'sidebar_menu_primary_font_color' => $settings['sidebar_menu_primary_font_color'],
                'sidebar_menu_secondary_font_color' => $settings['sidebar_menu_secondary_font_color'],
                'heading_primary_font_color' => $settings['heading_primary_font_color'],
                'heading_secondary_font_color' => $settings['heading_secondary_font_color'],
                'button_primary_color' => $settings['button_primary_color'],
                'avatar_bg_color' => $settings['avatar_bg_color'],
                'avatar_primary_font_color' => $settings['avatar_primary_font_color'],
                'avatar_secondary_font_color' => $settings['avatar_secondary_font_color'],
                'sidebar_font_color' => $settings['sidebar_font_color'],
                'width' => $settings['width'],
                'height' => $settings['height'],
                'logo_alignment' => $settings['logo_alignment']
            ];
        }
    }
    
    if (count($result_class) < 50) {

        return array('total_rows' => $totalrows, 'site_settings' => $array_return, 'maxreach' => 1);
    } else {
        return array('total_rows' => $totalrows, 'site_settings' => $array_return, 'maxreach' => 0);
    }
}


if ($postdata['function_type']  == "site_settings") {

    if (isset($postdata['search_string']) and !empty($postdata['search_string'])) {
        $search_string = trim($postdata['search_string']);
    } else {
        $search_string = null;
    }

    $limit = $postdata['limit'];
    $institution_id = trim($postdata['institution_id']);
  
   

    $page = (isset($postdata['page']) and isNumeric($postdata['page'])) ? (int)$postdata['page'] : 1;
    // $check_academic_confirmation = CheckAcademicSession($conn_rjllearning_specific, $institution_id);
    // if ($check_academic_confirmation != true) {
    //     errorreturn("Access denied. Academic session not active.");
    // }

    if ($limit != 'all') {
        $offset = ($page - 1) * $limit;
        $success['data'] = getInstitutionSiteSettings($conn_rjllearning_specific, $institution_id, $search_string, $limit, $offset);
        successreturn($success);
    } else {

        $success['data'] = getInstitutionSiteSettings($conn_rjllearning_specific, $institution_id, $search_string, $limit, null);
        successreturn($success);
    }
}
